/*-----------------------------------------------------------------------*
File........: browsedefs.i
Version.....: 1.0 (pre-beta) - 5/10/2000
Description : Procedures and functions that add robustness enhancements
                to the standard WebSpeed functionality
Input Param : <none>
Output Param: <none>
Author......: S.E. Southwell -  United Systems, Inc. (770) 449-9696
Copyright...: FreeFramework 2000 - http://www.freeframework.org
Created.....: 4/24/2000
Notes.......: Originally designed to work with WS 2.1, however, since 2.1 is 
              dead, this needs to be updated with the dynamic query logic.
*-----------------------------------------------------------------------*/
&GLOBAL-DEFINE BROWSEDEFS_I YES

DEFINE VAR v-queryhdl       AS HANDLE  EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-preparestring 	AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-defaultsort	AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-ascendingsort	AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-descendingsort	AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-bufferphrase	AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-bufferlist		AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-columnlabels   AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-columnfields   AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-defaultcolumnclass    AS CHAR    EXTENT {&QUERYCOUNT} INIT "datacell" NO-UNDO.
DEFINE VAR v-columnclass    AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-columndelimit  AS CHAR    EXTENT {&QUERYCOUNT} INITIAL "," NO-UNDO.
DEFINE VAR v-querytime		AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-querypage		AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-sort			AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-numperpage     AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-firsthit       AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-lasthit        AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-numpages       AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-queryend		AS LOGICAL EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-putresultnum	AS LOGICAL EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-maxrows		AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE VAR v-queryprocextra AS CHAR    EXTENT {&QUERYCOUNT} NO-UNDO. /*VERSION 2 ONLY*/

/*SHARED WITH THE CREATED PROCEDURE*/
DEFINE NEW SHARED VAR v-numresults AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE NEW SHARED VAR v-truncated  AS LOGICAL EXTENT {&QUERYCOUNT} NO-UNDO.
DEFINE NEW SHARED VAR h-browse     AS HANDLE NO-UNDO.

DEFINE VAR v-tempprocname 	AS CHAR NO-UNDO.
DEFINE VAR v-extranavparams AS CHAR NO-UNDO.
DEFINE VAR v-extranavvalues AS CHAR NO-UNDO.
DEFINE VAR v-paramcount 	AS INTEGER NO-UNDO.
DEFINE VAR v-qcount			AS INTEGER NO-UNDO.
DEFINE VAR v-qqcount		AS INTEGER NO-UNDO.
DEFINE VAR v-otherquerypages AS CHAR EXTENT {&QUERYCOUNT} NO-UNDO.

DEFINE STREAM s-procout.

ASSIGN
 v-tempprocname = ENTRY(3,WEB-CONTEXT:EXCLUSIVE-ID,":") + "_" + STRING(RANDOM(100,999))
 h-browse = THIS-PROCEDURE:HANDLE
.

/*Cross-link the browses so that navigation for one preserves navigation for the other*/
FUNCTION crossLinkBrowses RETURNS LOGICAL():
	DO v-qcount = 1 to {&QUERYCOUNT}:
		DO v-qqcount = 1 to {&QUERYCOUNT}:
			IF v-qqcount NE v-qcount
			 THEN ASSIGN v-otherquerypages[v-qcount] = v-otherquerypages[v-qcount]
			 + "&page_" + string(v-qqcount) + "=" + string(v-querypage[v-qqcount]).
		END.
	END.
END FUNCTION.

FUNCTION queryPrepare RETURNS LOGICAL (
 INPUT queryID AS INTEGER
):
	DEFINE VAR myprocname AS CHAR NO-UNDO.
	DEFINE VAR myqueryname AS CHAR NO-UNDO.
	DEFINE VAR v-cnt AS INTEGER NO-UNDO.

	/*set the extra navigational parameters, such as query info, the first time a query is prepared.*/
	IF v-extranavparams ne "" AND v-paramcount = 0 THEN DO v-paramcount = 1 TO NUM-ENTRIES(v-extranavparams):
		ASSIGN v-extranavvalues = v-extranavvalues + "&" + URL-ENCODE(ENTRY(v-paramcount,v-extranavparams),"QUERY")
	 		+ "=" + URL-ENCODE(GET-VALUE(ENTRY(v-paramcount,v-extranavparams)),"QUERY").
	END.
	
	ASSIGN
	 myprocname = v-tempprocname + "_" + STRING(queryID) + ".p"
	 myqueryname = "Q_" + STRING(queryID)
	 v-querytime[queryID] = etime
	.
	
	IF v-querypage[queryID] = 0 THEN ASSIGN v-querypage[queryID] = 1. 
	
	OUTPUT STREAM s-procout TO VALUE(myprocname).
	PUT STREAM s-procout UNFORMATTED
	 v-queryprocextra[queryID] SKIP
	 "DEFINE SHARED VAR h-browse AS HANDLE NO-UNDO." 		   	SKIP
	 "DEFINE SHARED VAR v-numresults AS INTEGER EXTENT {&QUERYCOUNT} NO-UNDO." 		   	SKIP
	 "DEFINE SHARED VAR v-truncated  AS LOGICAL EXTENT {&QUERYCOUNT} NO-UNDO." 		   	SKIP
	 "DEFINE QUERY " myqueryname " FOR " v-bufferphrase[queryID] " SCROLLING." 	SKIP
	 "OPEN QUERY " myqueryname " " v-preparestring[queryID] " "
	 (if v-sort[queryID] ne 0 then 
	 	if v-sort[queryID] > 0 then (
			if num-entries(v-ascendingsort[queryID],v-columndelimit[queryID]) >= v-sort[queryID]
			and entry(v-sort[queryID],v-ascendingsort[queryID],v-columndelimit[queryID]) ne ""
			then entry(v-sort[queryID],v-ascendingsort[queryID],v-columndelimit[queryID])
			else v-defaultsort[queryID]
		)
		else (
			if num-entries(v-descendingsort[queryID],v-columndelimit[queryID]) >= abs(v-sort[queryID])
			and entry(abs(v-sort[queryID]),v-descendingsort[queryID],v-columndelimit[queryID]) ne ""
			then entry(abs(v-sort[queryID]),v-descendingsort[queryID],v-columndelimit[queryID])
			else v-defaultsort[queryID]
		)
	  else v-defaultsort[queryID])
	 (if v-maxrows[queryID] ne 0 then " MAX-ROWS " + STRING(v-maxrows[queryid] + 1) else "") "." SKIP(2)
	 
     "IF NUM-RESULTS('" myqueryname "') > " v-maxrows[queryID] " AND " v-maxrows[queryID] " NE 0 THEN ASSIGN v-truncated = TRUE. " SKIP
	 "IF NOT v-truncated[" queryID "] THEN ASSIGN v-numresults[" queryID "] = NUM-RESULTS('" myqueryname "')."		SKIP
	 " ELSE ASSIGN v-numresults[" queryID "] = " v-maxrows[queryID] "." 											SKIP
	 "IF v-numresults[" queryID "] > 0 THEN DO: " 								SKIP
	 "    REPOSITION " myqueryname " FORWARDS " (v-numperpage[queryID] * (v-querypage[queryID] - 1)) "."	SKIP    
	 "END." 																	SKIP(2) 
	 "PROCEDURE putRow: " 														SKIP
	 "   DEFINE OUTPUT PARAMETER p-queryend AS LOGICAL NO-UNDO. "               SKIP
	 "   DEFINE OUTPUT PARAMETER p-textout  AS CHAR    NO-UNDO. "               SKIP
	 "   DEFINE VAR v-fieldbuckets  		AS CHAR    NO-UNDO. "               SKIP
	 "   GET NEXT " myqueryname ". " 											SKIP
	 "	 IF QUERY-OFF-END('" myqueryname "') THEN DO: "							SKIP
	 "       ASSIGN p-queryend = TRUE. "										SKIP
	 "	     RETURN. "															SKIP
	 "   END. "																	SKIP
	 'IF H-BROWSE:GET-SIGNATURE("each-row-' queryID '":U) BEGINS "PROCEDURE":U'	SKIP
	 ' THEN run each-row-' queryID ' IN h-browse (OUTPUT v-fieldbuckets,'		SKIP
	.
	DO v-cnt = 1 to NUM-ENTRIES(v-bufferlist[queryID]):
		PUT STREAM s-procout UNFORMATTED
		 if v-cnt ne 1 then ", " else ""
		 ' BUFFER ' ENTRY(v-cnt,v-bufferlist[queryID]) SKIP
		.
	END. /*each buffer in the query*/
	PUT STREAM s-procout UNFORMATTED
	 '). '											SKIP
	 "	 ASSIGN p-textout = p-textout "	                                    SKIP
	.
	DO v-cnt = 1 to NUM-ENTRIES(v-columnfields[queryID],v-columndelimit[queryID]):
		PUT STREAM s-procout UNFORMATTED
		 '    + ~'<TD CLASS="'
		 (if num-entries(v-columnclass[queryID],v-columndelimit[queryID]) >= v-cnt
		  and entry(v-cnt,v-columnclass[queryID],v-columndelimit[queryID]) ne ""
		  then entry(v-cnt,v-columnclass[queryID],v-columndelimit[queryID]) else v-defaultcolumnclass[queryID])
		 '">&nbsp~~~;~' + ' ENTRY(v-cnt,v-columnfields[queryID],v-columndelimit[queryID]) 
		 '    + ~'</TD>~'' SKIP
		.
	END. /*v-cnt*/
	PUT STREAM s-procout UNFORMATTED
	 "   . "																	SKIP
	 "END PROCEDURE. " 															SKIP
	.
	OUTPUT STREAM s-procout CLOSE.
	RUN VALUE(myprocname) PERSISTENT SET v-queryhdl[queryID] NO-ERROR.
	IF ERROR-STATUS:ERROR THEN DO:
		{&OUT} '<span class="error">Unable to open the query.</span>'.
		/* ||| */ QUEUE-MESSAGE("DEBUG","PrepareString is: " + v-preparestring[queryID]).
		ASSIGN v-queryTime[queryID] = etime - v-queryTime[queryID].
		RETURN FALSE.
	END.		
	&IF "{&DEBUG-ME}" = "YES" &THEN
	&ELSE
	OS-DELETE VALUE(myprocname).
	&ENDIF
	ASSIGN 
	 v-firsthit[queryID] = ((v-querypage[queryID] - 1) * v-numperpage[queryID]) + 1
	 v-lasthit[queryID] = min(v-querypage[queryID] * v-numperpage[queryID],v-numresults[queryID])
	 v-numpages[queryID] = TRUNCATE(v-numresults[queryID] / v-numperpage[queryID],0) 
	     + (if v-numresults[queryID] modulo v-numperpage[queryID] > 0 then 1 else 0)
	 v-queryTime[queryID] = etime - v-queryTime[queryID]
	.
	RETURN TRUE.

END FUNCTION.


FUNCTION prevButton RETURNS LOGICAL (
 INPUT queryID AS INTEGER
):
	IF v-querypage[queryID] > 1 THEN DO:
	{ {&INCLUDEPATH}browse_prev_button.i }
	END.
END FUNCTION.


FUNCTION pageNumbers RETURNS LOGICAL (
 INPUT queryID AS INTEGER
):
	DEFINE VAR v-pagecnt AS INTEGER NO-UNDO.
	IF v-numpages[queryID] > 2 THEN DO: 
		{ {&INCLUDEPATH}browse_page_links.i }
	END. /*more than 2 pages of results*/
END FUNCTION.


FUNCTION nextButton RETURNS LOGICAL (
 INPUT queryID AS INTEGER
):
	IF v-querypage[queryID] < v-numpages[queryID] THEN DO:
	{ {&INCLUDEPATH}browse_next_button.i }
	END.
	
END FUNCTION.

FUNCTION resultsShown RETURNS LOGICAL (
 INPUT queryID AS INTEGER
):
	{ {&INCLUDEPATH}browse_results_shown.i }
END FUNCTION.

FUNCTION putBrowse RETURNS LOGICAL (
 INPUT queryID AS INTEGER
):
	DEFINE VAR v-cnt 		AS INTEGER NO-UNDO.
	DEFINE VAR v-reccount 	AS INTEGER NO-UNDO.
	DEFINE VAR v-fl 		AS LOGICAL NO-UNDO.
	DEFINE VAR v-textout    AS CHAR    NO-UNDO. /*row of text from putrow*/
	
	{&OUT}
	 '	<tr class="headerrow">' 	SKIP
	.
	
	DO v-cnt = 1 TO NUM-ENTRIES(v-columnlabels[queryID],v-columndelimit[queryID]):
		IF NUM-ENTRIES(v-ascendingsort[queryID],v-columndelimit[queryID]) >= v-cnt
		 AND ENTRY(v-cnt,v-ascendingsort[queryID],v-columndelimit[queryID]) ne ""
		 THEN DO:
		{&OUT}
		 '		<td class="columnhdrsort"><span class="columnhdrsort"><a href="{&web-file}.html?sort_' queryID '=' 
		 (if abs(v-sort[queryID]) = v-cnt then (v-sort[queryID] * -1) else v-cnt) 
		 v-extranavvalues '" class="columnhdrsortlink">' SKIP
		 ENTRY(v-cnt,v-columnlabels[queryID],v-columndelimit[queryID]) 	SKIP
		 '		</a></span></td>'							SKIP
	 	.
		 
		END. /*sortable field*/
		ELSE DO: /*non-sortable field*/
		{&OUT}
		 '		<td class="columnheader">' 		SKIP
		 ENTRY(v-cnt,v-columnlabels[queryID],v-columndelimit[queryID]) 	SKIP
		 '		</td>'							SKIP
	 	.
		END. /*NON-SORTABLE FIELD*/
	END. /*EACH COLUMNLABEL FOR THIS QUERY*/
	
	{&OUT}
	 '	</tr>' 						SKIP
	.
	ASSIGN v-cnt = (v-queryPage[queryID] - 1) * v-numperpage[queryID]. /*re-initialize to use again*/
	DO WHILE NOT v-queryend[queryID] 
	 AND v-cnt < (v-querypage[queryID] * v-numperpage[queryID])
	 AND v-cnt < v-numResults[queryID]:
		ASSIGN
		 v-cnt = v-cnt + 1
		 v-fl = not v-fl
		.
		{&OUT} '<TR CLASS="datarow' TRIM(STRING(v-fl,"odd/even")) '">' skip.
		IF v-putresultnum[queryID] THEN DO:
		 { {&INCLUDEPATH}browse_result_num.i }
		END.
		RUN putrow IN v-queryhdl[queryID] (OUTPUT v-queryend[queryID], OUTPUT v-textout) NO-ERROR.
		IF ERROR-STATUS:ERROR THEN LEAVE.
		{&OUT} v-textout SKIP.
		{&OUT} "</TR>" SKIP.
		PUT STREAM WEBSTREAM CONTROL NULL(0).
	END. /*DO WHILE QUERY OPEN*/
	
END FUNCTION.
